#include <string.h>
#include <stdlib.h>
#include "geosim.h"
#include "gspriv.h"
#include "ietypes.h"
#include "windfunc.h"
#include "functnw.h"
#include "editrec.h"
/*#include "rootw.h"*/
#include "iemisc.h"
#include "helpmsg.h"

extern boolean funcwind;
static EditRec *nameEdit=NULL;
extern GSColor redCol, blackCol;

/* temporary function items */
static BigString tempFuncName;
boolean tempFuncActive, tempFuncMouseoff;
int tempFuncDtime;
/**/

/* list vars */
static GSlistHandle funcList;
static GSsclistHandle funcScroll;
static int numFuncs, curFunc;
/**/

/* internal protos */
void fTextFunc(GSlistHandle, int);
char *fLabelFunc(int);
void fInFunc();
void fOutFunc();
void fClickFunc(int);

void ClearTempFields();
void ResetButtons();
void ShowTempDtime();
static boolean TempFuncIsValid();
IEFunction *GetFunctionNum(int);
void SetUpFunctionList();
static void TempFieldsToItem(int);
static void ItemToTempFields(int);
/**/

extern IEIconfig iestate;

#define MAX_DTIME 10

void fTextFunc(GSlistHandle l, int slot)
{
	if (slot == curFunc)
		GSsetcolor(redCol);
	else
		GSsetcolor(blackCol);
}

void fInFunc()
{
}

void fOutFunc()
{
}

char *fLabelFunc(int slot)
{
	IEFunction *fn;
	
	if (slot < numFuncs) {
		fn = GetFunctionNum(slot);
		return fn->name;
		}
	else
		return " ";
}

void fClickFunc(int slot)
{
	int old = curFunc;
	/* click item:
			I. if temp stuff is valid and an item is
			currently selected, put temp stuff into curitem
			II. make 'slot' current
			III. put slot's fields into current
	*/
	
	if (TempFuncIsValid() && (curFunc != NO_ITEM))
		TempFieldsToItem(curFunc);
	
	curFunc = slot;
	GSdrawlistitem(funcList, New, old);		/* +++ should GSlist do */
	GSdrawlistitem(funcList, New, curFunc); /* this automatically? */
	
	ItemToTempFields(curFunc);
	GSenablebutton("functionw", "DeleteFunc", TRUE);
}	

static boolean TempFuncIsValid()
{
	return (strlen(tempFuncName)>0);
}

void ShowTempDtime()
{
/*	int x, y, wd, ht;
	GSColor col;
	BigString dtime_text;
	
	GSsetcurrentnamedwindow("functionw");
	GSgetfieldrect("dtime_disp", &x, &y, &wd, &ht, &col);
	
	GSsetcolor(col);
	GSwfillrect(x, y, wd, ht);
	
	ShadowRect(x, y, wd, ht, 1, Concave);
	
	sprintf(dtime_text, "%d", tempFuncDtime);
	
	GSsetcolor(blackCol);
	GSwwritemsg(x, y + SMALL, dtime_text);*/
	DrawNumField("dtime_disp", tempFuncDtime);
}

void ResetButtons()
{
	GSsetbuttontext("functionw", "MouseOffToggle", 
						tempFuncMouseoff? "Yes" : "No");
	GSsetbuttontext("functionw", "ActiveToggle", 
						tempFuncActive? "Active" : "Inactive");

	GSenablebutton("functionw", "ActiveToggle", TRUE);	
	GSenablebutton("functionw", "MouseOffToggle", TRUE);
	
	/*GSenablebutton("functionw", "dtimeinc", TRUE);	*/
	if (tempFuncDtime > 0)
		GSenablebutton("functionw", "dtimedec", TRUE);
	else
		GSdisablebutton("functionw", "dtimedec", TRUE);
}

void ClearTempFields()
{
	tempFuncName[0] = '\0';
	nameEdit->inspt = 0;
	tempFuncActive = tempFuncMouseoff = FALSE;
	tempFuncDtime = 1;
	ResetButtons();			/* +++ may want to disable some */
	ShowTempDtime();
	UpdateEditRec(nameEdit);
	GSdisablebutton("functionw", "DeleteFunc", TRUE);
}

static void TempFieldsToItem(int item)
{
	IEFunction *fn = GetFunctionNum(item);
	if (fn != NULL) {
		strcpy(fn->name, tempFuncName);
		fn->active = tempFuncActive;
		fn->dtime = tempFuncDtime;
		fn->mouseoff = tempFuncMouseoff;
		}
}

static void ItemToTempFields(int item)
{
	IEFunction *fn = GetFunctionNum(item);
	if (fn != NULL) {
		strcpy(tempFuncName, fn->name);
		nameEdit->inspt = 0;
		tempFuncActive = fn->active;
		tempFuncDtime = fn->dtime;
		tempFuncMouseoff = fn->mouseoff;
		}
	ResetButtons();
	ShowTempDtime();
	UpdateEditRec(nameEdit);
}

void SetUpFunctionList()
{
	int x, y, wd, ht;
	
	IEFunction *cur = iestate.funclisthead;
	
	curFunc = NO_ITEM;

	numFuncs = 0;
	
	while (cur != NULL) {
		numFuncs++;
		cur = cur->nextfunc;
		}
		
	GSgetdragareaspecs("functionw", "funcpick", 
				&x, &y, &wd, &ht, NULL, NULL);
	
	GSsclistsetup("functionw", "funcpick",
					1,
					"picklabel",
					0, 0,
					JUST_LEFT,
					fLabelFunc,
					fTextFunc,
					fInFunc,
					fOutFunc,
					fClickFunc,
					"funcscroll",
					GSconvertcolor("sclistcol"),
					GSconvertcolor("sclisttl"),
					GSconvertcolor("sclistbr"),
					numFuncs, 0,
					NULL,
					"fUpArrow",
					"fDownArrow",
					&funcList, &funcScroll);
					
	ShadowRect(x, y, wd, ht, THIN, Concave);
	GSdrawsclist(funcScroll);
}

void DrawFunctionWind()
{
	funcwind = TRUE;
	GSdrawnamedwindow("functionw", NO_BSTORE, NO_POPUP);
	GSsetcurrentnamedwindow("functionw");
	
	nameEdit = NewEditRec(tempFuncName, BIGSTRINGLEN, 1, SMALL,
			"functionw", "fname_edit", c_identifier_filter, NULL);

	SetUpFunctionList();
	UpdateEditRec(nameEdit);
	ClearTempFields();
	GSdisablemenuitem("Edit", "edit_functions");
	SetCurrentEditRec(nameEdit);
	GSdisplayhelpmessage(FUNC_H);
	ShowVersion();
}

void RedrawFunctionWind()
{
	int x, y, wd, ht;
	
	GSredrawnamedwindow("functionw");
	GSsetactivenamedwindow("functionw");
	UpdateEditRec(nameEdit);
	GSdrawsclist(funcScroll);
	ShowTempDtime();

	GSgetdragareaspecs("functionw", "funcpick", 
				&x, &y, &wd, &ht, NULL, NULL);
	ShadowRect(x, y, wd, ht, THIN, Concave);	
}

void RemoveFunctionWind()
{
	if (TempFuncIsValid() && (curFunc != NO_ITEM))
		TempFieldsToItem(curFunc);
	
	GSenablemenuitem("Edit", "edit_functions");
	DisposEditRec(nameEdit);
	nameEdit = NULL;
	GSdismantlesclist(funcScroll);
	GSremovenamedwindow("functionw");
	funcwind = FALSE;
}

/* callbacks */

boolean function_pick(int x, int y, DragStatusType status)
{
	GShandlelist(funcList, x, y, status);
}

boolean function_scroll(int x, int y, DragStatusType status)
{
	GShandlesclist(funcScroll, x, y, status);
}

boolean function_up()
{
	GShandleupbutton(funcScroll);
}

boolean function_down()
{
	GShandledownbutton(funcScroll);
}

boolean edit_function_name(int x, int y, DragStatusType status)
{
	if (nameEdit == NULL)
		return FALSE;
	if ((status == MOUSE_CLICK) || (status == DRAG_FINAL))
		SetCurrentEditRec(nameEdit);
}


boolean function_toggle_active()
{
	tempFuncActive = !tempFuncActive;

	GSsetbuttontext("functionw", "ActiveToggle", 
						tempFuncActive? "Active" : "Inactive");
							
	GSenablebutton("functionw", "ActiveToggle", TRUE);	
}


boolean function_inc_dtime()
{
	tempFuncDtime++;
	
	if (tempFuncDtime >= MAX_DTIME)
		GSdisablebutton("functionw", "dtimeinc", TRUE);
		
	if (tempFuncDtime == 1)
		GSenablebutton("functionw", "dtimedec", TRUE);

	ShowTempDtime();
}


boolean function_dec_dtime()
{
	if (tempFuncDtime > 0)
		tempFuncDtime--;
		
	if (tempFuncDtime <= 0)
		GSdisablebutton("functionw", "dtimedec", TRUE);
		
	if (tempFuncDtime == MAX_DTIME - 1)
		GSenablebutton("functionw", "dtimeinc", TRUE);

	ShowTempDtime();
}


boolean function_toggle_mouseoff()
{
	tempFuncMouseoff = !tempFuncMouseoff;

	GSsetbuttontext("functionw", "MouseOffToggle", 
						tempFuncMouseoff? "Yes" : "No");
							
	GSenablebutton("functionw", "MouseOffToggle", TRUE);	
}

IEFunction *GetFunctionNum(int num)
{
	IEFunction *cur = iestate.funclisthead;
	
	if (num < 0)
		return NULL;
		
	while (cur != NULL) {
		if (num == 0)
			return cur;
		num--;
		cur = cur->nextfunc;
		}
		
	return NULL;
}

boolean new_function()
{
	int old = curFunc;
	
	if (TempFuncIsValid()) {
		if (curFunc == NO_ITEM) {
		
			IEFunction *newfunc;
			newfunc = (IEFunction *) malloc(sizeof(IEFunction));
			
			if (iestate.funclisttail == NULL)
				iestate.funclisthead 
					= iestate.funclisttail = newfunc;
			else {
				iestate.funclisttail->nextfunc = newfunc;
				iestate.funclisttail = newfunc;
				}
			newfunc->nextfunc = NULL;
			++numFuncs;
			TempFieldsToItem(numFuncs-1);
			GSsetsclistnumitems(funcScroll, numFuncs, TRUE);
			}
		
		else
			TempFieldsToItem(curFunc);
		}
	
	curFunc = NO_ITEM;
	ClearTempFields();
	
	if (old != NO_ITEM)
		GSdrawlistitem(funcList, New, old);
}

boolean delete_function()
{
	IEFunction *prev = NULL, *cur;
	
	if (curFunc < 0) { /* shouldn't be here anyway */
		GSdisablebutton("functionw", "DeleteFunc", TRUE);
		return;
		}

	if (curFunc > 0) {
		prev = GetFunctionNum(curFunc-1);
		cur = prev->nextfunc;
		prev->nextfunc = cur->nextfunc;
		}
	else {   /* cur is start of list */
		cur = iestate.funclisthead;
		iestate.funclisthead = cur->nextfunc;
		}
		
	if (iestate.funclisttail == cur)
		iestate.funclisttail = prev;
		
	free(cur);
	curFunc = NO_ITEM;
	GSsetsclistnumitems(funcScroll, --numFuncs, TRUE);
	ClearTempFields();
}
