#include <string.h>
#include "geosim.h"
#include "gspriv.h"
#include "rootw.h"
#include "windfunc.h"

boolean filewind = TRUE, miscwind = FALSE, aliaswind=FALSE,
	messagewind = FALSE, interfaceWind = FALSE, funcwind=FALSE,
	confirmwind = FALSE, objwind = FALSE, palwind = FALSE;
boolean windpop = FALSE, windPropPop = FALSE;
GraphicsFileType GraphFileFmt = NO_FILE; 

/*char *curEditItem;*/

/* Internal protos */
static void ToggleEditItems(char *);
/**/

static void ToggleEditItems(char *itemName)
{
/*	if (curEditItem != NULL)
		GStogglecheck("Edit", curEditItem);
	GStogglecheck("Edit", itemName);*/
}

void remove_active_window()
{
	/* +++ here's where a window list would be nice */
	if (filewind)
		RemoveFileWind();
	if (miscwind)
		RemoveMiscWind();
	if (aliaswind)
		RemoveAliasWind();
	if (messagewind)
		RemoveMessageWind();
	if (funcwind)
		RemoveFunctionWind();
	if (palwind)
		RemovePaletteWind();
	if (interfaceWind)
		RemoveInterfaceWind();
}

boolean redrawfunc(void)
{
	/* +++ Replace this with some kind of window-list
		scheme.
		*/
	if (interfaceWind) {
		RedrawInterfaceWind();
		/* interface popups */
		if (windpop)
			RedrawVWindsPopup();
		if (windPropPop)
			RedrawWPropWind();
		if (objwind)
			RedrawPropWind();
		return;
		}
	GSredrawnamedwindow("root");
	GSredrawnamedwindow("message");
	GSdisplayhelpmessage(CURR_MSG);
	ShowVersion();
	if (filewind)
		RedrawFileWind();
	if (miscwind)
		RedrawMiscWind();
	if (aliaswind)
		RedrawAliasWind();
	if (messagewind)
		RedrawMessageWind();
	if (funcwind)
		RedrawFunctionWind();
	if (palwind)
		RedrawPaletteWind();
	if (confirmwind)
		RedrawConfirmWind();
		
}

boolean edit_misc(char *itemName)
{
	ToggleEditItems(itemName);
	if (miscwind)
		return;
	/*curEditItem = E_MISC;*/
	remove_active_window();
	DrawMiscWind();
}

boolean edit_aliases(char *itemName)
{
	ToggleEditItems(itemName);
	if (aliaswind)
		return;
	/*curEditItem = E_ALIASES;*/
	remove_active_window();
	DrawAliasWind();
}

boolean edit_messages(char *itemName)
{
	ToggleEditItems(itemName);
	if (messagewind)
		return;
	/*curEditItem = E_MESSAGES;*/
	remove_active_window();
	DrawMessageWind();
}

boolean edit_functions(char *itemName)
{
	ToggleEditItems(itemName);
	if (funcwind)
		return;
	/*curEditItem = E_FUNCTIONS;*/
	remove_active_window();
	DrawFunctionWind();
}

boolean edit_palette(char *itemName)
{
	if (palwind)
		return;
	/*curEditItem = E_PALETTE;*/
	remove_active_window();
	DrawPaletteWind();
}

boolean edit_interface(char *itemName)
{
	ToggleEditItems(itemName);
	if (interfaceWind)
		return;
	/*curEditItem = E_INTERFACE;*/
	remove_active_window();
	DrawInterfaceWind();
}

boolean dump_screen(char *i)
{
	BigString namestr;
	strcpy(namestr, "builder");
	if (!GSdumpscreen(namestr, GraphFileFmt))
		GSbell();
}

void ShowVersion()
{
	GSdisplayversion("version.txt");
}
