#include <stdlib.h>
#include <stdio.h>
#include "geosim.h"
#include "mmincl.h"

#define BWD 2  /* Width of the sider bar */
/***********************************************************************
Draw a slider bar at the specified position of the specified size.
***********************************************************************/
double drawslider(
  int x,
  int y,
  int width,
  int height,
  GSColor barcolor,
  GSColor tickcolor, int position)
{
  int offset;

  GSsetcolor(barcolor);
  GSwdrawline(x, y, x, y+height);
  GSwdrawline(x+width, y, x+width, y+height);
  GSwdrawline(x, y+height/2, x+width, y+height/2);
  if (position <= x)
    offset = 0;
  else if (position > (x + width - BWD))
    offset = width - (BWD+1);
  else
    offset = position - (x+1);
  GSsetcolor(tickcolor);
  GSwfillrect(x+1+offset, y+1, BWD, height-1);
  return((double)offset/(double)(width-(BWD+1)));
}
