/*================================ triang.h ================================*/

/* Header file for use with "triang.c".  We define the Triangle and Edge
** data structures, and provide a prototype for the function triangulate.
*/

#include "GraphicsGems.h"

typedef struct triangle {
    Point2             *p[3];    /* the three vertices */
    struct triangle    *t[3];    /* the neighboring triangles */
    int                 nt;      /* number of neighboring triangles */
} Triangle;

typedef struct edge {
    Point2      *p, *q;    /* the two endpoints */
    Triangle    *t, *u;    /* the triangles that this edge is between */
    }
    Edge;

long      triangulate(Point2 *, long, Edge *, long *, Triangle *);

/*==========================================================================*/

